theory MList 
imports Main
begin

datatype 'a mlist = Mt | Cons 'a "'a mlist"

fun len :: "'a mlist \<Rightarrow> nat"
where "len Mt = 0"
    | "len (Cons x xs) = 1+ len xs"

fun app :: "'a mlist \<Rightarrow> 'a mlist \<Rightarrow> 'a mlist"
where "app Mt ys = ys"
    | "app (Cons x xs) ys = Cons x (app xs ys)"

lemma app_unit_r: "app xs Mt= xs"
 apply (induct xs)
 apply (simp, simp)
 done
 

lemma app_assoc: "app (app xs ys) zs = app xs (app ys zs)"
  apply (induct xs)
  apply (simp)+
  done

lemma len_app: "len (app xs ys) = len xs+ len ys"
 apply (induct "xs")
 apply (simp)
 apply (simp)
 done

fun rev :: "'a mlist \<Rightarrow> 'a mlist"
where "rev Mt = Mt"
    | "rev (Cons x xs) = app (rev xs) (Cons x Mt)"

lemma rev_app: "rev (app xs ys) = app (rev ys) (rev xs)"
  apply (induct xs)
  apply (simp add: app_unit_r app_assoc)+
  done

lemma rev_idem: "rev o rev = id"
  apply (rule ext)
  apply (induct_tac "x")
  apply (simp)
  apply (simp add: rev_app)
  done

end
