theory Relations
imports "Main"
begin

type_synonym  'x R = "('x * 'x) set"

definition reflexive :: "'x R \<Rightarrow> bool"
where "reflexive R == \<forall>x. (x, x) : R"

definition symmetric :: "'x R \<Rightarrow> bool"
where "symmetric R == \<forall> x y. (x, y) : R \<longrightarrow> (y, x) : R"

axiomatization graph :: "('x\<Rightarrow> 'x) \<Rightarrow> 'x R"
where graphI: "y= f x \<Longrightarrow> (x, y) : graph f"
  and graphE: "(x, y) : graph f \<Longrightarrow> y= f x"

lemma id_refl: "reflexive (graph id)"
  apply (unfold id_def)
  apply (unfold reflexive_def)
  apply (clarify)
  apply (rule graphI)
  apply (simp)
  done

lemma id_refl2: "reflexive (graph id)"
  apply (force simp add: id_def reflexive_def intro: graphI)
  done

end


